> ## Documentation Index
> Fetch the complete documentation index at: https://developers.partoo.co/llms.txt
> Use this file to discover all available pages before exploring further.

# Duplicate Custom Role

> Duplicate a Custom Role.
A new Custom Role with (almost) the same `name` and `api_id`, and identical `description` and `permissions` will be created in your organization.

The new `name` will be the same as the original role, with an added suffix
  - `"My Custom Role"` → `"My Custom Role - 2"`

And similar for the `api_id`:
  - `"my_custom_role"` → `"my_custom_role_2"`




## OpenAPI

````yaml /assets/openapi/openapi-bundled.yaml post /custom_role/duplicate
openapi: 3.1.0
info:
  title: Partoo Rest API
  version: v2
  license:
    name: © Copyright Partoo
    url: https://www.partoo.co/en/gtu-api/
  x-logo:
    url: >-
      https://partoo-client-images.s3.amazonaws.com/logo-partoo-restapi-white.png
  description: >
    ## Introduction

    The Partoo Rest API allows you to automate all the actions that are possible
    to do in the Partoo Web Application.


    The Partoo Rest API can be used for many different purposes:
      - Create/update/delete your businesses & users if you are a client.
      - Create/subscribe/manage organizations, businesses & users if you are a reseller.
      - Retrieve data on businesses you have access to if you are a publisher.
      - ...
servers:
  - url: https://api.partoo.co/v2
    description: Production server
  - url: https://api.sandbox.partoo.co/v2
    description: Sandbox server (dev environment for clients & partners)
security:
  - ApiKeyAuth: []
paths:
  /custom_role/duplicate:
    post:
      tags:
        - Custom Roles
      summary: Duplicate Custom Role
      description: >
        Duplicate a Custom Role.

        A new Custom Role with (almost) the same `name` and `api_id`, and
        identical `description` and `permissions` will be created in your
        organization.


        The new `name` will be the same as the original role, with an added
        suffix
          - `"My Custom Role"` → `"My Custom Role - 2"`

        And similar for the `api_id`:
          - `"my_custom_role"` → `"my_custom_role_2"`
      operationId: duplicateCustomRole
      parameters:
        - $ref: '#/components/parameters/query_org_id'
        - $ref: '#/components/parameters/path_custom_role_api_id'
      responses:
        '200':
          description: OK
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/CustomRoleDuplicateResponse'
        '401':
          $ref: '#/components/responses/401'
        '403':
          $ref: '#/components/responses/403'
        '404':
          $ref: '#/components/responses/404'
components:
  parameters:
    query_org_id:
      in: query
      name: org_id
      schema:
        type: integer
      required: false
      description: >
        Organization ID. Only `PROVIDER` users can specify a different
        organization. If not provided, defaults to your own organization.
    path_custom_role_api_id:
      in: path
      required: true
      name: custom_role_api_id
      schema:
        type: string
      description: API identifier of the custom role (`api_id`)
  schemas:
    CustomRoleDuplicateResponse:
      description: Response for successfully duplicating a custom role
      allOf:
        - $ref: '#/components/schemas/CustomRoleBase'
        - type: object
          properties:
            api_id:
              type: string
              description: API identifier of the duplicated custom role.
              example: my_custom_role_2
    CustomRoleBase:
      type: object
      properties:
        name:
          type: string
          description: >-
            Name of the Custom Role. Cannot contain any of the following
            characters: `,;/\|<>`.
          example: This is My Custom Role
        api_id:
          type: string
          description: >-
            API identifier of the Custom Role. Cannot contain any of the
            following characters: `,;/\|<>`.
          example: this_is_my_custom_role
        description:
          type: string
          example: It has a custom permission configuration!
        org_id:
          oneOf:
            - $ref: '#/components/schemas/OrgId'
            - type: 'null'
        is_builtin:
          type: boolean
          example: false
    OrgId:
      description: Unique identifier of an organization in Partoo.
      type: integer
      example: 42
  responses:
    '401':
      description: You are not authenticated
      content:
        application/json:
          schema:
            description: Error that occurs when you are not authenticated
            type: object
            properties:
              errors:
                type: object
                description: The detail of the error encountered
                properties:
                  authentication:
                    type: string
                    default: User not authenticated
    '403':
      description: |
        You are not allowed to perform this action
      content:
        application/json:
          schema:
            description: >
              Error that occurs when you are authenticated but you are trying to
              perform an action you are not allowed to perform
            type: object
            properties:
              errors:
                type: object
                description: The detail of the error encountered
                properties:
                  authorization:
                    type: string
                    default: Operation not allowed
    '404':
      description: Resource does not exist
      content:
        application/json:
          schema:
            description: >-
              Error that occcurs when you are trying to reach a resource that
              does not exist
            type: object
            properties:
              errors:
                type: object
                description: The detail of the error encountered
                properties:
                  json:
                    type: string
                    default: Resource not found
  securitySchemes:
    ApiKeyAuth:
      description: >
        The authentication system on Partoo API is using API Key that should be
        put in the header of the request (the name of the header is `x-APIKey`).
        An api_key is linked to a user. This user's role will give you different
        access level to the API features.
      type: apiKey
      in: header
      name: x-APIKey

````